unit MainForm;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs, FMX.Layouts,
  FMX.ListBox, FMX.Controls.Presentation, FMX.StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    ListBox1: TListBox;
    Layout1: TLayout;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
    FActiveControl: TControl;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses
  ClassTypeFactoryUnit;

{$R *.fmx}

procedure TForm1.Button1Click(Sender: TObject);
var
  Info: TViewItemClassInfo;
  Item: TListBoxItem;
begin
  for Info in TViewItemFactory.Instance.List do
  begin
    Item := TListBoxItem.Create(ListBox1);
    Item.Parent := ListBox1;
    Item.Text := Info.Id;
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  Id: string;
  ItemClass: TViewItemClass;
begin
  if not Assigned(ListBox1.Selected) then
    Exit;

  if Assigned(FActiveControl) then
    FActiveControl.Free;

  Id := ListBox1.Selected.Text;

  // case #1
  ItemClass := TViewItemFactory.Instance.GetClass(Id);
  FActiveControl := ItemClass.Create(Self);
  FActiveControl.Parent := Layout1;
  FActiveControl.Align := TAlignLayout.Client;

  // case #2
//  FActiveControl := TViewItemFactory.Instance.CreateControl(Id);
end;

end.
